clear all;
global C;

C = 4*pi*pi;
k = 7;   
h = 2^(-k);

% Sttzstellen
x = 0:h:1;
y = x;

% Die Fusspunkte der Basisfkten liegen innerhalb des Quadrats, nicht am
% Rand:
[X,Y] = meshgrid(x(2:(end-1)),y(2:(end-1)));

% Die Randwerte muessen jedoch am Rand definiert werden, d.h. auf einem
% Mesh mit einer weiteren Stuetzstellenreihe auf jeder Seite...
[Xw, Yw] = meshgrid(x,y);
s = length(x)-2;


% A wird die Matrix fr das LGS und B dient zur Berechnung des Ladevektors
A = sparse(s^2,s^2);
B = sparse(s^2,s^2);
korrekturterm = zeros(1,s^2);

% w : Enthaelt die Randwerte
z = zeros(s+2,s+2);
z = f_rand(Xw,Yw);

% Entferne innere Werte (setze zu Null), falls anders definiert
% Behalte w fuer Fehleranalyse...
w(1,:) = z(1,:); w(s+2,:) = z(s+2,:); w(:,1) = z(:,1); w(:,s+2) = z(:,s+2);
w = sparse(w);

a = C*h^2/2-4; % Diagonalelement

% Besetzung der Matrizen A,B wie fuer homogene Randbedingungen
for i=1:s^2
    [I,J] = ind2sub([s,s],i);  % Koordinaten des Sttzpunktes
    if (I+1)<=s
        j = sub2ind([s,s],I+1,J); %Nummer des benachbarten Punktes
        A(i,j) = 2*(C*h^2/24+1/2); % Term fr vertikale Nachbarschaft
        B(i,j) = 2*h^2/24;    
    end
    if (J+1)<=s
        j = sub2ind([s,s],I,J+1);
        A(i,j) = 2*(C*h^2/24+1/2); % Term fr horizontale Nachbarschaft
        B(i,j) = 2*h^2/24;
    end
    if (I+1<=s) && (J+1)<=s
        j = sub2ind([s,s],I+1,J+1); % schrge Nachbarschaft
        A(i,j) = 2*C*h^2/24;
        B(i,j) = 2*h^2/24;
    end
end

d1 = a*ones(s^2,1); 
d2 = h^2/2*ones(s^2,1);
A = A+A'+spdiags(d1,0,s^2,s^2); A = sparse(A);
B = B+B'+spdiags(d2,0,s^2,s^2); B = sparse(B);


% Bestimme Korrekturterm fuer inhomogene Randbedingung
% Beachte, dass die Indizes um +1 verschoben sind, damit Zugriff
% auf Matrix z stimmt!
for i=1:s^2
    [I,J] = ind2sub([s,s],i);       
    if  (J==1) || (J==s) || (I==1) || (I==s)
        %Zusaetzliche Integrale fuer Ladevektor, vgl Folie:
        korrekturterm(i) = (-w(I,J+1) - w(I+1,J) - w(I+1,J+2) - w(I+2,J+1)) - ...
            C*(h^2)*(1/12)*(w(I,J+1) + w(I+1,J) + w(I,J+2) + w(I+2,J+1) + w(I+1,J+2) + w(I+2,J));
    end
end


% Auswertung der Funktion f
F = zeros(s,s);
%F = f(X,Y);
realF = reshape(F, s^2, 1 );
load = B * realF;
load = load + korrekturterm';
v = A\load;

%figure(1); surf(Xw,Yw, w); title('Hilfsfunktion');

v2 = zeros(s+2);
v2(2:s+1,2:s+1) = reshape(v,s,s);
v2 = v2+w;
figure(2); surf(Xw,Yw,v2); title('Loesung mit geforderten Randwerten');

%nochmal den maximalen Fehler ausgeben, macht nur Sinn falls w nicht nur
%die Randwerte repraesentiert sondern selbst die analytische Loesung ist
max(max(abs(v2-z)))
    

